import c4d
from c4d import gui

# Layerscript by Christian Behrendt
# www.christian-behrendt.com
# Version 0.1
# 09.02.2014

GROUP_ID1 = 1000
CHECKBOX_ID1 = 1001
CHECKBOX_ID2 = 1002
CHECKBOX_ID3 = 1003
CHECKBOX_ID4 = 1004
BUTTON_ID1 = 1005
BUTTON_ID2 = 1006
matlist = []
Opt1 = True
Opt2 = True
Opt3 = True

def main(var1,var2,var3):
    
        obj = doc.GetActiveObjects(1)
        for x in obj:
            tags = x.GetTags()        
            if var2 == True:
                for x in tags:
                    if x.GetType() == 5616:
                        mat = x.GetMaterial()
                        matlist.append(x)
                        matlist.append(mat)
                    
                for x in matlist:
                    if var3 == True:
                        if layer != x[c4d.ID_LAYER_LINK]:
                            x[c4d.ID_LAYER_LINK] = layer
                    else:
                        if x[c4d.ID_LAYER_LINK] == None:
                            x[c4d.ID_LAYER_LINK] = layer
        
            if var1 == True:
                for x in obj:
                    if var3 == True:
                        if layer != x[c4d.ID_LAYER_LINK]:
                            x[c4d.ID_LAYER_LINK] = layer
                    else:
                        if x[c4d.ID_LAYER_LINK] == None:
                            x[c4d.ID_LAYER_LINK] = layer
                        
class PopupDialog(gui.GeDialog):
    
    def CreateLayout(self):
        self.GroupBegin(GROUP_ID1, c4d.BFH_SCALEFIT, 1, title = 'Einstellungen:') 
        self.GroupBorder(c4d.BORDER_GROUP_IN) 
        self.GroupBorderSpace(20, 5, 20, 5) 
        self.AddCheckbox(CHECKBOX_ID1, c4d.BFH_SCALEFIT, 0, 0, 'Unterobjekte einschließen?')
        self.AddCheckbox(CHECKBOX_ID2, c4d.BFH_SCALEFIT, 0, 0, 'Ebenen übertragen?') 
        self.AddCheckbox(CHECKBOX_ID3, c4d.BFH_SCALEFIT, 0, 0, 'Materialebenen übertragen?')
        self.AddCheckbox(CHECKBOX_ID4, c4d.BFH_SCALEFIT, 0, 0, 'Bestehende Zuweisungen überrschreiben?')
        self.AddDlgGroup(c4d.DLG_OK|c4d.DLG_CANCEL)  
        self.GroupEnd()
        return True 
   
    def InitValues(self):
        self.SetBool(CHECKBOX_ID1,True)
        self.SetBool(CHECKBOX_ID2,True)
        self.SetBool(CHECKBOX_ID3,True)
        self.SetBool(CHECKBOX_ID4,True)
        return True
    
    def Command(self,id,msg):
        if id == c4d.DLG_OK:
            
            if dlg.GetBool(CHECKBOX_ID1) == True:
                c4d.CallCommand(100004768)
                
            if dlg.GetBool(CHECKBOX_ID2) == True:
                Opt1 = True
            else:
                Opt1 = False
                
            if dlg.GetBool(CHECKBOX_ID3) == True:
                Opt2 = True
            else:
                Opt2 = False
                
            if dlg.GetBool(CHECKBOX_ID4) == True:
                Opt3 = True
            else:
                Opt3 = False
            
            main(Opt1,Opt2,Opt3)     
            self.Close()
            
        if id == c4d.DLG_CANCEL:
            self.Close()
            
        return True
    
            
 
if __name__=='__main__':
    doc = c4d.documents.GetActiveDocument()
    parent = doc.GetActiveObject()
    layer = parent[c4d.ID_LAYER_LINK]
    dlg = PopupDialog()
    dlg.Open(c4d.DLG_TYPE_MODAL, defaultw=300, defaulth=50)
    c4d.EventAdd()
